﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using ModbusDemo.windows;
using ModbusDemo;
using ModbusDemo.Modular;
using ModbusDemo.Common;
using System.Threading;
namespace ModbusDemo.MessageFormat
{
    public class ModualControl
    {
        public class Op
        {
            public ushort duration { get; set; }
            public UInt64 startTime { get; set; }
            public int d0 { get; set; }
            public int d1 { get; set; }
            public int d2 { get; set; }
            public int d3 { get; set; }
            public int d4 { get; set; }
            public int d5 { get; set; }
            public int d6 { get; set; }
            public int d7 { get; set; }
            public UInt64 ts { get; set; }

        }

        public class SsItem
        {
            public string addr { get; set; }
            public Op op { get; set; }
        }

        public class MqttRoot
        {
            public string taskId { get; set; }
            public List<SsItem> ss { get; set; }
        }
        public class Cfg
        {
            public byte d0 { get; set; }
            public byte d1 { get; set; }
            public byte d2 { get; set; }
            public byte d3 { get; set; }
            public byte d4 { get; set; }
            public byte d5 { get; set; }
            public byte d6 { get; set; }
            public byte d7 { get; set; }
            public string name {get; set; }
            public string down { get; set; }
            public string upper { get; set; }
            public UInt64 ts { get; set; }
        }

        public class pcCfgSsItem
        {
            public string addr { get; set; }
            public Cfg cfg { get; set; }
        }

        public class pcCfgRoot
        {
            public string taskId { get; set; }
            public List<pcCfgSsItem> ss { get; set; }
        }

        public class pcModualControlIndex
        {
            public string srcId   { get; set; }
            public string srcType { get; set; }
            public string srcCh   { get; set; }
            public string opType  {get;  set; }
            public string resId   { get; set; }
            public string resType { get; set; }
            public string resCh   { get; set; }
            public List<string> dstCh { get; set; }
        }

        public class pcControlMap
        {
            public List<pcModualControlIndex> chMap { get; set; }
        }
        public struct ModualRespControl
        {
            public byte byResModualID;
            public string stResChannel;
            public modual.eModualType eModualType;
        }
        public class ModualCntrol
        {
            public bool bStartControl;
            public bool bControlStatus;
            public byte sbModbusID;
            public byte sbModualIndex;
            public bool[] bControlData;
            public ushort usDurationTime;
            public UInt64 ulStartTime;
            public bool[] bControlBit = new bool[8];
            public modual.eModualType eModualType;
            public bool  bOpenMachine;
            public ModualRespControl xModualRespControl;
        }

        public class pcLiquidLevelConfig
        {
            public byte         byModbusID;
            public string       stChannelNumber;
            public double       dUpLevel;
            public double       dDownLevel;
        }
        public static List<pcLiquidLevelConfig> cPoolLevelConfig = new List<pcLiquidLevelConfig>();
        public static List<ModualCntrol> liModuualControl = new List<ModualCntrol>();
        public const ushort usDefineControlTimes = 1;
        private static pcControlMap cControlMap = new pcControlMap();
        private static object obLock = new object();
#if DEBUG_TEST
        public const string strMapCfg = "{chMap:[" +
                                                "{ \"srcId\": \"31\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d1\", \"dstCh\":[\"d1\",\"d2\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +

                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +

                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," + 

                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +


                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d4\", \"dstCh\":[\"d4\",\"d5\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d6\", \"dstCh\":[\"d6\",\"d7\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                        "]}";
#endif
        public static void vGetaWay_Receive_Control(string sDataString, out string stResponseData)
        {
            byte byModualIndex = 0;
            MqttRoot cControl = new MqttRoot();
            var jsonObj = new JObject();
            try
            {
                cControl = JsonConvert.DeserializeObject<MqttRoot>(sDataString);
                jsonObj = JObject.Parse(sDataString);
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Control Mqtt Parse Fail");
            }
            for (int i = 0; i < cControl.ss.Count; i++)
            {
                bool[] btReadTempData = new bool[6];
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModualCntrol cModualCntrol = new ModualCntrol
                {
                    sbModbusID = byte.Parse(cControl.ss[i].addr),
                    usDurationTime = (ushort)(cControl.ss[i].op.duration * 60),
                    ulStartTime = cControl.ss[i].op.startTime
                };
                cModualCntrol.eModualType = eModdusId_Find_ModualType(cControl.ss[i].addr);
                if (cModualCntrol.eModualType == modual.eModualType.WTDR66C)
                {
                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cModualCntrol.bControlData, cModualCntrol.sbModbusID, 16, 6);
                    for (byte j = 0; j < ModualPoll.byX66cNumber; j++)
                    {
                        if (cModualCntrol.sbModbusID == ModualPoll.byX66cIdlist[j])
                        {
                            byModualIndex = j;
                            cModualCntrol.sbModualIndex = j;
                            break;
                        }
                        else
                        {
                            byModualIndex = 0xFF;
                            cModualCntrol.sbModualIndex = 0xFF;
                        }
                    }
                }
                else if(cModualCntrol.eModualType == modual.eModualType.WTDR78C)
                {
                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cModualCntrol.bControlData, cModualCntrol.sbModbusID, 16, 8);
                    for (byte j = 0; j < ModualPoll.byX66cNumber; j++)
                    {
                        if (cModualCntrol.sbModbusID == ModualPoll.byX78cIdlist[j])
                        {
                            byModualIndex = j;
                            cModualCntrol.sbModualIndex = j;
                            break;
                        }
                        else
                        {
                            byModualIndex = 0xFF;
                            cModualCntrol.sbModualIndex = 0xFF;
                        }
                    }
                }
                if (jsonObj["ss"][i]["op"] != null)
                {
                    if (jsonObj["ss"][i]["op"]["d0"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr,"d0",Convert.ToBoolean(cControl.ss[i].op.d0),ref cModualCntrol);
                    }
                    if (jsonObj["ss"][i]["op"]["d1"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr,"d1",Convert.ToBoolean(cControl.ss[i].op.d1),ref cModualCntrol);
                    }
                    if (jsonObj["ss"][i]["op"]["d2"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr,"d2",Convert.ToBoolean(cControl.ss[i].op.d2),ref cModualCntrol);
                    }
                    if (jsonObj["ss"][i]["op"]["d3"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr,"d3",Convert.ToBoolean(cControl.ss[i].op.d3),ref cModualCntrol);
                    }
                    if (jsonObj["ss"][i]["op"]["d4"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr,"d4",Convert.ToBoolean(cControl.ss[i].op.d4),ref cModualCntrol);
                    }
                    if (jsonObj["ss"][i]["op"]["d5"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr, "d5", Convert.ToBoolean(cControl.ss[i].op.d5), ref cModualCntrol);

                    }
                    if (jsonObj["ss"][i]["op"]["d6"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr, "d6", Convert.ToBoolean(cControl.ss[i].op.d6), ref cModualCntrol);

                    }
                    if (jsonObj["ss"][i]["op"]["d7"] != null)
                    {
                        vFindChannelMap(cControl.ss[i].addr, "d7", Convert.ToBoolean(cControl.ss[i].op.d7), ref cModualCntrol);
                    }
                    
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && cModualCntrol.ulStartTime <= Form1.GetTimeStamp())
                    {
                        cModualCntrol.bStartControl = true;
                        ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(cModualCntrol.sbModbusID, 16, cModualCntrol.bControlData);
                        if (cModualCntrol.eModualType == modual.eModualType.WTDR66C)
                            ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, cModualCntrol.sbModbusID, 16, 6);
                        else if(cModualCntrol.eModualType == modual.eModualType.WTDR78C)
                            ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, cModualCntrol.sbModbusID, 16, 8);
                        if (Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                        {
                            cModualCntrol.bControlStatus = true;
                        }
                    }
                    if (jsonObj["ss"][i]["op"]["ts"] != null)
                    {
                        jsonObj["ss"][i]["op"]["ts"] = Form1.GetTimeStamp();
                    }
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        lock (obLock)
                        {
                            vDelete_Same_Control(cModualCntrol);
                            if (cModualCntrol.bStartControl == true && cModualCntrol.ulStartTime != 0 && cModualCntrol.bControlStatus == true)
                            {
                                liModuualControl.Add(cModualCntrol);
                            }
                            else if (cModualCntrol.bStartControl == false && cModualCntrol.ulStartTime != 0)
                            {
                                liModuualControl.Add(cModualCntrol);
                            }
                        }
                    }
                    for (int k = 0; k < 8; k++)
                    {
                        if (cModualCntrol.bControlBit[k] == true && ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            string str = "d"+k.ToString();
                            jsonObj["ss"][i]["op"][str] = 1;
                            if (byModualIndex != 0xFF && k < 6)
                            {
                                if (cModualCntrol.eModualType == modual.eModualType.WTDR66C)
                                {
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usCommFailTimes[k] = 0;
                                    if (cModualCntrol.bStartControl == true && Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData))
                                        ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                }
                                else if(cModualCntrol.eModualType == modual.eModualType.WTDR78C)
                                {
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usNowAlarmCode[k+8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usCommFailTimes[k+8] = 0;
                                    if (cModualCntrol.bStartControl == true && cModualCntrol.bStartControl == true)
                                        ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usNowAlarmCode[k+8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                }
                            }
                        }
                        else if (cModualCntrol.bControlBit[k] == true)
                        {
                            string str = "d"+k.ToString();
                            jsonObj["ss"][i]["op"][str] = 0;
                            if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR && byModualIndex != 0xFF)
                            {
                                if (cModualCntrol.eModualType == modual.eModualType.WTDR66C)
                                {
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usCommFailTimes[k] += usDefineControlTimes;
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                }
                                else if (cModualCntrol.eModualType == modual.eModualType.WTDR78C)
                                {
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usNowAlarmCode[k+8] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usCommFailTimes[k+8] += usDefineControlTimes;
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usNowAlarmCode[k+8] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                }
                            }
                            if (!Enumerable.SequenceEqual(cModualCntrol.bControlData, btReadTempData) && byModualIndex != 0xFF && cModualCntrol.bStartControl == true)
                            {
                                if (cModualCntrol.eModualType == modual.eModualType.WTDR66C)
                                    ModualPoll.cx66c.sX66cAlarmStruct[byModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                else if (cModualCntrol.eModualType == modual.eModualType.WTDR78C)
                                    ModualPoll.cx78c.sX78cAlarmStruct[byModualIndex].usNowAlarmCode[k + 8] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                            }
                        }
                    }
                }
            }
            stResponseData = jsonObj.ToString();
        }

        public static void vControl_Poll()
        {
           cControlMap = JsonConvert.DeserializeObject<pcControlMap>(strMapCfg);
            while (true)
            {
                lock (obLock)
                {
                    for (sbyte i = 0; i < liModuualControl.Count; i++)
                    {
                        if (liModuualControl[i].bStartControl == false)
                        {
                            if (liModuualControl[i].ulStartTime <= Form1.GetTimeStamp())
                            {
                                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                                liModuualControl[i].bStartControl = true;
                                bool[] bControlData = new bool[6];
                                bool[] btReadTempData;
                                byte ChannelNumber = 0;
                                if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                {
                                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 6);
                                    ChannelNumber = 6;
                                }
                                else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                {
                                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 8);
                                    ChannelNumber = 8;
                                }
                                for (sbyte j = 0; j < ChannelNumber; j++)
                                {
                                    if (liModuualControl[i].bControlBit[j] == true)
                                    {
                                        bControlData[j] = liModuualControl[i].bControlData[j];
                                    }
                                    else
                                    {
                                        liModuualControl[i].bControlData[j] = bControlData[j];
                                    }
                                    ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(liModuualControl[i].sbModbusID, 16, bControlData);
                                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, liModuualControl[i].sbModbusID, 16, ChannelNumber);
                                    if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                    {
                                        for (sbyte k = 0; k < ChannelNumber; k++)
                                        {
                                            if (liModuualControl[i].bControlBit[k] == true && liModuualControl[i].sbModualIndex != 0xFF)
                                            {
                                                if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                                {
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] += usDefineControlTimes;
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                                }
                                                else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                                {
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] += usDefineControlTimes;
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                                }
                                            }
                                        }
                                    }
                                    else if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                    {
                                        for (sbyte k = 0; k < ChannelNumber; k++)
                                        {
                                            if (liModuualControl[i].bControlBit[k] == true && liModuualControl[i].sbModualIndex != 0xFF)
                                            {
                                                if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                                {
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] = 0;
                                                    if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                                        ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                                }
                                                else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                                {
                                                    ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                                    ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] = 0;
                                                    if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                                        ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if ((liModuualControl[i].usDurationTime + liModuualControl[i].ulStartTime) <= Form1.GetTimeStamp())
                            {
                                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                                bool[] bControlData = new bool[6];
                                bool[] btReadTempData;
                                byte ChannelNumber = 0;
                                byte byOperatinChannelNUmber = 0;
                                if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                {
                                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 6);
                                    ChannelNumber = 6;
                                }
                                else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                {
                                    ChannelNumber = 8;
                                    ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bControlData, liModuualControl[i].sbModbusID, 16, 8);
                                }
                                for (sbyte k = 0; k < ChannelNumber; k++)
                                {
                                    if (liModuualControl[i].bControlBit[k] == true)
                                    {
                                        byOperatinChannelNUmber++;
                                    }
                                }
                                for (sbyte j = 0; j < ChannelNumber; j++)
                                {
                                    if (byOperatinChannelNUmber == 3)
                                    {
                                        if (liModuualControl[i].bControlBit[j] == true && j != 2)
                                        {
                                            bControlData[j] = !liModuualControl[i].bControlData[j];
                                        }
                                    }
                                    else
                                    {
                                        if (liModuualControl[i].bControlBit[j] == true)
                                        {
                                            bControlData[j] = !liModuualControl[i].bControlData[j];
                                        }
                                    }
                                }
                                ModbusErrorCode |= ModbusComm.Modbus_WriteMultipleCoils(liModuualControl[i].sbModbusID, 16, bControlData);
                                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out btReadTempData, liModuualControl[i].sbModbusID, 16, ChannelNumber);
                                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                {
                                    for (sbyte k = 0; k < ChannelNumber; k++)
                                    {
                                        if (liModuualControl[i].bControlBit[k] == true && liModuualControl[i].sbModualIndex != 0xFF)
                                        {
                                            if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                            {
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] += usDefineControlTimes;
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                            }
                                            else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                            {
                                                ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                                                ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] += usDefineControlTimes;
                                                ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] |= (ushort)ModualAlarm.eAlarmCode.ChannelControlError;
                                            }
                                        }
                                    }
                                }
                                else if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                                {
                                    for (sbyte k = 0; k < ChannelNumber; k++)
                                    {
                                        if (liModuualControl[i].bControlBit[k] == true && liModuualControl[i].sbModualIndex != 0xFF)
                                        {
                                            if (liModuualControl[i].eModualType == modual.eModualType.WTDR66C)
                                            {
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                                ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] = 0;
                                                if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                                    ModualPoll.cx66c.sX66cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                            }
                                            else if (liModuualControl[i].eModualType == modual.eModualType.WTDR78C)
                                            {
                                                ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                                                ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] = 0;
                                                if (Enumerable.SequenceEqual(bControlData, btReadTempData))
                                                    ModualPoll.cx78c.sX78cAlarmStruct[liModuualControl[i].sbModualIndex].usNowAlarmCode[k + 8] &= (ushort)~ModualAlarm.eAlarmCode.ChannelControlError;
                                            }
                                        }
                                    }
                                }
                                liModuualControl.Remove(liModuualControl[i]);
                                break;
                            }
                        }
                    }
                }
                Thread.Sleep(100);
            }
        }

        public static modual.eModualType eModdusId_Find_ModualType(string sModbusID)
        {
            for (int i = 0; i < ModualPoll.byX66cNumber; i++)
            {
                if (byte.Parse(sModbusID) == ModualPoll.cx66c.byModbusID[i])
                {
                    return modual.eModualType.WTDR66C;
                }
            }
            for (int i = 0; i < ModualPoll.byX18xNumber; i++)
            {
                if (byte.Parse(sModbusID) == ModualPoll.cx78c.byModbusID[i])
                {
                    return modual.eModualType.WTDR78C;
                }
            }

                    //if(cControlMap.chMap[i].srcType == "WTDR14P")
                    //    return modual.eModualType.WTDR14P;
                    //else if(cControlMap.chMap[i].srcType == "WTDR18X")
                    //    return modual.eModualType.WTDR18X;
                    //else if(cControlMap.chMap[i].srcType == "WTDR78C")
                    //    return modual.eModualType.WTDR78C;
                    //else if(cControlMap.chMap[i].srcType == "WTDR66C")
                    //    return modual.eModualType.WTDR66C;

            return modual.eModualType.IDLE;
        }
        private static void vFindChannelMap(string stContrID, string stChannelName, bool bControlValue,ref ModualCntrol cModualCntrol)
        {
            bool bHadRef = false;
            if (bControlValue == true)
            {
                cModualCntrol.bOpenMachine = true;
            }
            for (int i = 0; i < cControlMap.chMap.Count; i++)
            {
                if (cControlMap.chMap[i].srcId == stContrID)
                {
                    bHadRef = true;
                    if (cControlMap.chMap[i].srcCh == stChannelName && cControlMap.chMap[i].dstCh.Count != 0)
                    {
                        if (cControlMap.chMap[i].opType == "durOp")
                        {
                            cModualCntrol.usDurationTime = 1;
                            cModualCntrol.ulStartTime    = 0xFF;
                        }
                        for (int j = 0; j < cControlMap.chMap[i].dstCh.Count; j++)
                        {
                            for (int k = 0; k < 8; k++)
                            {
                                string str = "d" + k.ToString();
                                if (cControlMap.chMap[i].dstCh[j] == str)
                                {
                                    if (cControlMap.chMap[i].dstCh.Count == 3)
                                    {
                                        if (j == 0)
                                        {
                                            cModualCntrol.bControlData[k] = bControlValue;
                                        }
                                        else if (j == 1)
                                        {
                                            cModualCntrol.bControlData[k] = true;
                                        }
                                        else if (j == 2)
                                        {
                                            cModualCntrol.bControlData[k] = !bControlValue;
                                        }
                                        else
                                        {
                                            cModualCntrol.bControlData[k] = bControlValue;
                                        }
                                    }
                                    else if (cControlMap.chMap[i].dstCh.Count == 2)
                                    {
                                        cModualCntrol.bControlData[k] = bControlValue;
                                     }
                                    cModualCntrol.bControlBit[k] = true;
                                }
                            }
                        }
                        cModualCntrol.xModualRespControl.byResModualID = byte.Parse(cControlMap.chMap[i].resId);
                        cModualCntrol.xModualRespControl.eModualType   = eModdusId_Find_ModualType(cControlMap.chMap[i].resId);
                        cModualCntrol.xModualRespControl.stResChannel  = cControlMap.chMap[i].resCh;
                    }
                    else
                    {
                        for (int k = 0; k < 8; k++)
                        {
                            string str = "d" + k.ToString();
                            if (stChannelName == str)
                            {
                                cModualCntrol.bControlData[k] = bControlValue;
                                cModualCntrol.bControlBit[k] = true;
                            }
                        }
                    }
                }
            }
            if (bHadRef == false)
            {
                for (int k = 0; k < 8; k++)
                {
                    string str = "d" + k.ToString();
                    if (stChannelName == str)
                    {
                        cModualCntrol.bControlData[k] = bControlValue;
                        cModualCntrol.bControlBit[k] = true;
                    }
                }
            }
        }

        //public static ModbusComm.eModbusErrorCode eOperation_Machine(ModualCntrol cModualCntrol, out bool bControlStatus, ModualRespControl sModualRespControl)
        //{ 


          


        //}
        public static void vDelete_Same_Control(ModualCntrol cModualCntrol)
        {
            for (sbyte i = 0; i < liModuualControl.Count; i++)
            {
                if (liModuualControl[i].sbModbusID == cModualCntrol.sbModbusID)
                {
                    if (Enumerable.SequenceEqual(liModuualControl[i].bControlBit, cModualCntrol.bControlBit))
                    {
                        liModuualControl.Remove(liModuualControl[i]);
                    }
                }
            }
        }
        public static void vPoolLevelParse(string stConfigString, out string stResponseStrign)
        {
            pcCfgRoot cCfgRoot = new pcCfgRoot();
            var jsonObj = new JObject();
            try
            {
                cCfgRoot = JsonConvert.DeserializeObject<pcCfgRoot>(stConfigString);
                jsonObj = JObject.Parse(stConfigString);
                for (int i = 0; i < cCfgRoot.ss.Count; i++)
                {
                    pcLiquidLevelConfig cLiquidLevelConfig = new pcLiquidLevelConfig
                    {
                        byModbusID = byte.Parse(cCfgRoot.ss[i].addr),
                        dUpLevel = double.Parse(cCfgRoot.ss[i].cfg.upper),
                        dDownLevel = double.Parse(cCfgRoot.ss[i].cfg.down)
                    };
                    string strChannelString = "d" + i.ToString();
                    for (int j = 0; j < 8; j++)
                    {

                        if (jsonObj["ss"][i]["cfg"].Value<string>("name") == strChannelString)
                        {
                            cLiquidLevelConfig.stChannelNumber = strChannelString;
                            jsonObj["ss"][i]["cfg"][strChannelString] = 1;
                            break;
                        }
                    }
             
                    if (jsonObj["ss"][i]["cfg"]["ts"] != null)
                    {
                        jsonObj["ss"][i]["cfg"]["ts"] = Form1.GetTimeStamp();
                    }
                    cPoolLevelConfig.Add(cLiquidLevelConfig);
                }
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Cfg Mqtt Parse Fail");
                stResponseStrign = "";
            }
            finally
            {
                stResponseStrign = jsonObj.ToString();
            }
        }
    }
}